package org.amse.gk.grapheditor;

import java.io.File;

import org.amse.gk.grapheditor.gui.*;
import org.amse.gk.grapheditor.io.GraphReader;
import org.amse.gk.grapheditor.io.ReadGraphException;
import org.amse.gk.grapheditor.model.*;
import org.amse.gk.grapheditor.model.impl.GraphFactory;

public class GraphEditor {
	@SuppressWarnings("unused")
	private MainFrame myMainFrame;
	private IGraph myGraph;
	
	public GraphEditor(){
		myGraph = loadSavedGraph();
		myMainFrame = new MainFrame(myGraph, Settings.load());		
	}
	
	private IGraph loadSavedGraph(){
		IGraph g = GraphFactory.createGraph();				
		GraphReader r;
		r = new GraphReader(new File(System.getProperty("user.home") + 
			"/.graph.grf"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e) {			
		}
		
		return g;
	}

}
