package org.amse.gk.grapheditor.algorithms;

import java.awt.Color;

import org.amse.gk.grapheditor.model.IElement;
import org.amse.gk.grapheditor.model.IGraph;

/**
 * Interface describes an algorithm, which can be applied to {@link IGraph}.
 * Its work can be represented with a {@link GraphicPanel}.
 *  
 */
public interface IAlgorithm {
	
	/**
	 * @return the first step of the algorithm
	 */
	IStep getFirstStep();	

	/**
	 * @return the description of algorithm, some start information
	 *         for explaining its work  
	 */
	String getDescription();	 
	
	/**
	 * @param e An element, which we want to paint.
	 * @return the color, which shows the current state of the element.
	 */
	Color getColor(IElement e);
}
