package org.amse.gk.grapheditor.algorithms;

import org.amse.gk.grapheditor.model.IVertex;

/**
 * Interface is used for such step, that requires some additional
 * outside information, like the vertex to start.
 * Extends {@link IStep}
 * 
 * @see IStep  
 *  
 */
public interface IChooseVertexStep extends IStep {
	/**
	 * Special method allows to set step information (start vertex)
	 * from outside the algorithm.
	 *  
	 * @param v  Vertex, which will be used in algorithm step 
	 */
	void setVertex(IVertex v); 

}
