package org.amse.gk.grapheditor.gui;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.NoSuchElementException;
import java.util.Scanner;

public class Settings {
	private int myX;
	private int myY;
	private int myWidth;
	private int myHeight;
	private String myState;
	private String myDirectory;
	
	public Settings(int x, int y, int width, int height, String state, String directory) {
		myX = x;
		myY = y;
		myWidth = width;
		myHeight = height;
		myState = state;	
		myDirectory = directory;
	}
	
	public int getX() {
		return myX;
	}
	
	public int getY() {
		return myY;
	}
	
	public int getHeight() {
		return myHeight;
	}
	
	public int getWidth() {
		return myWidth;
	}
	
	public String getState() {
		return myState;
	}
	
	public String getDirectory() {
		return myDirectory; 
	}
	
	
	public static Settings load() {
		Settings s = null;
		int x = 200, y = 200, width = 400, height = 400;
		String state = "AddVertex";
		String directory = null;
		try {			
			Scanner scanner = new Scanner(new File(System.getProperty("user.home") + 
			"/.GE_window.ini"));
			x = scanner.nextInt();			
			y = scanner.nextInt();			
			width = scanner.nextInt();
			height = scanner.nextInt();
			state = scanner.next();
			directory = scanner.next();
		} catch (IOException e) {			
			//e.printStackTrace();		
		} catch (NoSuchElementException e) {
			//e.printStackTrace();
		} finally {
			s = new Settings(x, y, width, height, state, directory);
		}
		return s;
	}
	
	public void save() {
		try {
			FileWriter w = new FileWriter(new File(System.getProperty("user.home") + 
					"/.GE_window.ini"));
			w.append(new Integer(myX).toString());
			w.append(' ');
			w.write(new Integer(myY).toString());
			w.append(' ');
			w.write(new Integer(myWidth).toString());
			w.append(' ');
			w.write(new Integer(myHeight).toString());
			w.append(' ');
			w.write(myState);
			w.append(' ');
			if (myDirectory != null) {
				w.write(myDirectory);
			}
			w.flush();
		} catch (IOException e) {			
			//e.printStackTrace();
		}	
	}

}
