package org.amse.gk.grapheditor.gui.view.states;

import java.awt.event.MouseEvent;

import org.amse.gk.grapheditor.gui.view.IViewState;
import org.amse.gk.grapheditor.gui.view.GraphicPanel;
import org.amse.gk.grapheditor.model.IVertex;

@SuppressWarnings("serial")
public class AddVertexState extends StateAdaptor implements IViewState {

	private IVertex myActiveVertex;
	
	public AddVertexState(GraphicPanel graphicPanel, String iconName) {
		super(graphicPanel, "AddVertex", iconName);		
	}	

	@Override
	public void mousePressed(MouseEvent e) {
		unselectAllElements();
		if (myActiveVertex != null) {
			myActiveVertex = null;				
			getGraphicPanel().updateAll();			
			return ;
		}					
		if (getGraphicPanel().getVertex(e.getX(), e.getY()) == null){
			myActiveVertex = getGraphicPanel().getGraph().addVertex(e.getX(), e.getY());			
			selectElement(myActiveVertex);				
		}		
		getGraphicPanel().updateAll();
	}			
			
	@Override
	public void mouseDragged(MouseEvent e) {		
		if (myActiveVertex != null){
			int x = e.getX(), y = e.getY();
			if (y < 0) {
				myActiveVertex.move(myActiveVertex.getX(), 0);
			} else if (y > getGraphicPanel().getHeight()) {
				myActiveVertex.move(myActiveVertex.getX(), getGraphicPanel().getHeight());
			} else {
				myActiveVertex.move(myActiveVertex.getX(), y);
			}
			if (x < 0) {
				myActiveVertex.move(0, myActiveVertex.getY());				
			} else if (x > getGraphicPanel().getWidth()) {				
				myActiveVertex.move(getGraphicPanel().getWidth(), myActiveVertex.getY());	
			} else {
				myActiveVertex.move(x, myActiveVertex.getY());
			}
			getGraphicPanel().updateAll();
		} 				
	}
	
	@Override
	public void mouseReleased(MouseEvent e) {
		if (myActiveVertex != null){				
			myActiveVertex = null;
			unselectAllElements();
			getGraphicPanel().updateAll();
		}
	}

	@Override
	public String getDescription() {
		return "Add vertex";
	}
	
	@Override
	public boolean isEnabled() {
		return true;
	}
	
}
