package org.amse.gk.grapheditor.model;

/**
 * Interface describes a directed edge, an element of {@link IGraph}. 
 * An edge defined by two vertices, starting and terminal.
 * Extends an interface {@link IElement}.
 * Implementations: {@link AbstractEdge}
 * 
 * @see IGraph
 * @see IElement
 * @see AbstractEdge
 */

public interface IEdge extends IElement {
	/** 
	 * Returns the starting vertex of the edge
	 */
	public IVertex getVertexFrom();
	/** 
	 * Returns the final vertex of the edge
	 */
	public IVertex getVertexTo();	
}
