package org.amse.gk.grapheditor.model;

/**
 * Interface describes an abstract vertex, element of {@link IGraph} 
 * with coordinates on a plane.
 * Extends an interface {@link IElement}. 
 * Implementations: {@link AbstractVertex} 
 * 
 * @see IGraph
 * @see IElement
 * @see AbstractVertex
 */

public interface IVertex extends IElement {
	/**
	 * Returns the X-coordinate of the vertex
	 */
	public int getX();
	/**
	 * Returns the Y-coordinate of the vertex
	 */
	public int getY();
	/**
	 * Moves the vertex to a new position with given coordinates	 
	 */ 
	public void move(int x, int y);
	/**
	 * Returns the name of the vertex 
	 */
	public String getName();
}
