package org.amse.gk.grapheditor.model.impl;

import org.amse.gk.grapheditor.model.IEdge;
import org.amse.gk.grapheditor.model.IVertex;

/**
 * Class AbstractEdge is a basic implementation for {@link IEdge} interface.
 * It keeps data about directed edge by using references to starting and terminal vertices.
 * This class provides all optional IEdge operations.  
 *
 * @see IEdge
 */

class AbstractEdge implements IEdge{
	/** 
	 * The starting vertex
	 */
	private IVertex myFrom;
	
	/**
	 * The final vertex
	 */
	private IVertex myTo;
	
	/** 
	 * Constructs an edge with given starting and final vertices. 
	 * 
	 * @param from The starting vertex
	 * @param to   The final vertex
	 */
	
	public AbstractEdge(IVertex from, IVertex to){
		myFrom = from;
		myTo = to;
	}
	
	/** 
	 * @return the starting vertex of the edge
	 */
	public IVertex getVertexFrom() {		
		return myFrom;
	}	
	
	/** 
	 * @return the final vertex of the edge
	 */
	public IVertex getVertexTo() {		
		return myTo;
	}
	
}
