package org.amse.gk.grapheditor.tests;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;

import org.amse.gk.grapheditor.algorithms.IChooseVertexStep;
import org.amse.gk.grapheditor.algorithms.IStep;
import org.amse.gk.grapheditor.algorithms.StepType;
import org.amse.gk.grapheditor.algorithms.creators.BreadthFirstSearchCreator;
import org.amse.gk.grapheditor.algorithms.impl.BreadthFirstSearch;
import org.amse.gk.grapheditor.io.GraphReader;
import org.amse.gk.grapheditor.io.ReadGraphException;
import org.amse.gk.grapheditor.model.IGraph;
import org.amse.gk.grapheditor.model.impl.GraphFactory;

import junit.framework.TestCase;

public class AlgorithmTests extends TestCase {
	public void test0() {
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/algorithms/test0.grf"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		BreadthFirstSearchCreator bfs = new BreadthFirstSearchCreator();
	
		assertTrue(!bfs.isAlgorithmEnabled(g));
	}
	
	public void test1() {
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/algorithms/test1.grf"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}		
		BreadthFirstSearch bfs = new BreadthFirstSearch(g);
		IStep step;
		File newf = new File("org/amse/gk/grapheditor/utils/algorithms/test1_.txt");
		File oldf = new File("org/amse/gk/grapheditor/utils/algorithms/test1.txt");
		boolean areEqual = false;
		try {
			FileWriter fr = new FileWriter(newf);
			step = bfs.getFirstStep();
			if (step instanceof IChooseVertexStep) {
				IChooseVertexStep s = (IChooseVertexStep) step;
				s.setVertex(g.vertices().get(0));				
			}
			while (step.getStepType() != StepType.FINAL_STEP) {			
				step.run();
				fr.append(bfs.toString());				
				step = step.nextStep();
			}
			
			fr.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			FileInputStream newFIS = new FileInputStream(newf);
			FileInputStream oldFIS = new FileInputStream(oldf);
			areEqual = true;
			while (newFIS.available() != 0 && oldFIS.available() != 0) {
				if (!(newFIS.read() == oldFIS.read())) {
					areEqual = false;
					break;
				}
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		assertTrue(areEqual);
	}
	
	
	public void test2() {
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/algorithms/test2.grf"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			e1.printStackTrace();
		}		
		BreadthFirstSearch bfs = new BreadthFirstSearch(g);
		IStep step;
		File newf = new File("org/amse/gk/grapheditor/utils/algorithms/test2_.txt");
		File oldf = new File("org/amse/gk/grapheditor/utils/algorithms/test2.txt");
		boolean areEqual = false;
		try {
			FileWriter fr = new FileWriter(newf);
			step = bfs.getFirstStep();
			if (step instanceof IChooseVertexStep) {
				IChooseVertexStep s = (IChooseVertexStep) step;
				s.setVertex(g.vertices().get(0));				
			}
			while (step.getStepType() != StepType.FINAL_STEP) {			
				step.run();
				fr.append(bfs.toString());				
				step = step.nextStep();
			}
			
			fr.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			FileInputStream newFIS = new FileInputStream(newf);
			FileInputStream oldFIS = new FileInputStream(oldf);
			areEqual = true;
			while (newFIS.available() != 0 && oldFIS.available() != 0) {
				if (!(newFIS.read() == oldFIS.read())) {
					areEqual = false;
					break;
				}
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		assertTrue(areEqual);
	}
	
	public void test3() {
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/algorithms/test3.grf"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			e1.printStackTrace();
		}		
		BreadthFirstSearch bfs = new BreadthFirstSearch(g);
		IStep step;
		File newf = new File("org/amse/gk/grapheditor/utils/algorithms/test3_.txt");
		File oldf = new File("org/amse/gk/grapheditor/utils/algorithms/test3.txt");
		boolean areEqual = false;
		try {
			FileWriter fr = new FileWriter(newf);
			step = bfs.getFirstStep();
			if (step instanceof IChooseVertexStep) {
				IChooseVertexStep s = (IChooseVertexStep) step;
				s.setVertex(g.vertices().get(0));				
			}
			while (step.getStepType() != StepType.FINAL_STEP) {			
				step.run();
				fr.append(bfs.toString());				
				step = step.nextStep();
			}
			
			fr.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			FileInputStream newFIS = new FileInputStream(newf);
			FileInputStream oldFIS = new FileInputStream(oldf);
			areEqual = true;
			while (newFIS.available() != 0 && oldFIS.available() != 0) {
				if (!(newFIS.read() == oldFIS.read())) {
					areEqual = false;
					break;
				}
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		assertTrue(areEqual);
	}
	
	public void test4() {
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/algorithms/test4.grf"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			e1.printStackTrace();
		}		
		BreadthFirstSearch bfs = new BreadthFirstSearch(g);
		IStep step;
		File newf = new File("org/amse/gk/grapheditor/utils/algorithms/test4_.txt");
		File oldf = new File("org/amse/gk/grapheditor/utils/algorithms/test4.txt");
		boolean areEqual = false;
		try {
			FileWriter fr = new FileWriter(newf);
			step = bfs.getFirstStep();
			if (step instanceof IChooseVertexStep) {
				IChooseVertexStep s = (IChooseVertexStep) step;
				s.setVertex(g.vertices().get(0));				
			}
			while (step.getStepType() != StepType.FINAL_STEP) {			
				step.run();
				fr.append(bfs.toString());				
				step = step.nextStep();
			}
			
			fr.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			FileInputStream newFIS = new FileInputStream(newf);
			FileInputStream oldFIS = new FileInputStream(oldf);
			areEqual = true;
			while (newFIS.available() != 0 && oldFIS.available() != 0) {
				if (!(newFIS.read() == oldFIS.read())) {
					areEqual = false;
					break;
				}
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		assertTrue(areEqual);
	}
	
	public void test5() {
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/algorithms/test5.grf"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			e1.printStackTrace();
		}		
		BreadthFirstSearch bfs = new BreadthFirstSearch(g);
		IStep step;
		File newf = new File("org/amse/gk/grapheditor/utils/algorithms/test5_.txt");
		File oldf = new File("org/amse/gk/grapheditor/utils/algorithms/test5.txt");
		boolean areEqual = false;
		try {
			FileWriter fr = new FileWriter(newf);
			step = bfs.getFirstStep();
			if (step instanceof IChooseVertexStep) {
				IChooseVertexStep s = (IChooseVertexStep) step;
				s.setVertex(g.vertices().get(0));				
			}
			while (step.getStepType() != StepType.FINAL_STEP) {			
				step.run();
				fr.append(bfs.toString());				
				step = step.nextStep();
			}
			
			fr.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			FileInputStream newFIS = new FileInputStream(newf);
			FileInputStream oldFIS = new FileInputStream(oldf);
			areEqual = true;
			while (newFIS.available() != 0 && oldFIS.available() != 0) {
				if (!(newFIS.read() == oldFIS.read())) {
					areEqual = false;
					break;
				}
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		assertTrue(areEqual);
		
	}
	public void test6() {
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/algorithms/test6.grf"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			e1.printStackTrace();
		}		
		BreadthFirstSearch bfs = new BreadthFirstSearch(g);
		IStep step;
		File newf = new File("org/amse/gk/grapheditor/utils/algorithms/test6_.txt");
		File oldf = new File("org/amse/gk/grapheditor/utils/algorithms/test6.txt");
		boolean areEqual = false;
		try {
			FileWriter fr = new FileWriter(newf);
			step = bfs.getFirstStep();
			if (step instanceof IChooseVertexStep) {
				IChooseVertexStep s = (IChooseVertexStep) step;
				s.setVertex(g.vertices().get(0));				
			}
			while (step.getStepType() != StepType.FINAL_STEP) {			
				step.run();
				fr.append(bfs.toString());				
				step = step.nextStep();
			}
			
			fr.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			FileInputStream newFIS = new FileInputStream(newf);
			FileInputStream oldFIS = new FileInputStream(oldf);
			areEqual = true;
			while (newFIS.available() != 0 && oldFIS.available() != 0) {
				if (!(newFIS.read() == oldFIS.read())) {
					areEqual = false;
					break;
				}
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		assertTrue(areEqual);
	}
}
