package org.amse.gk.grapheditor.tests;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

import junit.framework.TestCase;

import org.amse.gk.grapheditor.io.GraphReader;
import org.amse.gk.grapheditor.io.GraphWriter;
import org.amse.gk.grapheditor.io.ReadGraphException;
import org.amse.gk.grapheditor.model.IGraph;
import org.amse.gk.grapheditor.model.impl.GraphFactory;

public class IOTest extends TestCase {
	public void test0(){
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/xml/test0.xml"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		assertTrue(g.toString().equals("0"));
	}
	
	public void test1(){
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/xml/test1.xml"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		assertTrue(g.toString().equals("4\nVertex0 100 100\nVertex1 150 150\nVertex2 120 120\nVertex3 150 100"));
	}
	
	public void test2(){
		IGraph g = GraphFactory.createGraph();		
		GraphReader r = new GraphReader(new File("org/amse/gk/grapheditor/utils/xml/test2.xml"));
		try {
			r.readGraph(g);
		} catch (ReadGraphException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		assertTrue(g.toString().equals("4\nVertex0 0 0\nVertex1 10 5\nVertex2 20 10\nVertex3 30 15\n" +
				"Edge: Vertex0 -> Vertex1\n" +
				"Edge: Vertex0 -> Vertex2\n" +
				"Edge: Vertex0 -> Vertex3\n" +
				"Edge: Vertex1 -> Vertex0\n" +
				"Edge: Vertex2 -> Vertex3"));
	}
	
	public void test3(){
		IGraph g = GraphFactory.createGraph();
		File out = new File("org/amse/gk/grapheditor/utils/xml/test0.xml");
		GraphReader r = new GraphReader(out);
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}	
		File in = new File("org/amse/gk/grapheditor/utils/xml/test0w.xml");
		GraphWriter w = new GraphWriter(g);		
		w.writeGraph(in);
		Scanner sout = null;		
		Scanner sin = null;
		try {			
			sout = new Scanner(out);
			sin = new Scanner(in);
		} catch (FileNotFoundException e) {			
			e.printStackTrace();
		}		
		boolean areEqual = true;
		while (sout.hasNext() && sin.hasNext()) {
			if (!sout.next().equals(sin.next())) {
				areEqual = false;
				break;
			}
		}
		if (sout.hasNext() || sin.hasNext()) {
			areEqual = false;
		}
		assertTrue(areEqual);
	}
	
	public void test4() {
		IGraph g = GraphFactory.createGraph();
		File out = new File("org/amse/gk/grapheditor/utils/xml/test1.xml");
		GraphReader r = new GraphReader(out);
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}	
		File in = new File("org/amse/gk/grapheditor/utils/xml/test1w.xml");
		GraphWriter w = new GraphWriter(g);		
		w.writeGraph(in);
		Scanner sout = null;		
		Scanner sin = null;
		try {			
			sout = new Scanner(out);
			sin = new Scanner(in);
		} catch (FileNotFoundException e) {			
			e.printStackTrace();
		}		
		boolean areEqual = true;
		while (sout.hasNext() && sin.hasNext()) {
			if (!sout.next().equals(sin.next())) {
				areEqual = false;
				break;
			}
		}
		if (sout.hasNext() || sin.hasNext()) {
			areEqual = false;
		}
		assertTrue(areEqual);		
	}
	
	public void test5() {
		IGraph g = GraphFactory.createGraph();
		File out = new File("org/amse/gk/grapheditor/utils/xml/test2.xml");
		GraphReader r = new GraphReader(out);
		try {
			r.readGraph(g);
		} catch (ReadGraphException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}	
		File in = new File("org/amse/gk/grapheditor/utils/xml/test2w.xml");
		GraphWriter w = new GraphWriter(g);		
		w.writeGraph(in);
		Scanner sout = null;		
		Scanner sin = null;
		try {			
			sout = new Scanner(out);
			sin = new Scanner(in);
		} catch (FileNotFoundException e) {			
			e.printStackTrace();
		}		
		boolean areEqual = true;
		while (sout.hasNext() && sin.hasNext()) {
			if (!sout.next().equals(sin.next())) {
				areEqual = false;
				break;
			}
		}
		if (sout.hasNext() || sin.hasNext()) {
			areEqual = false;
		}
		assertTrue(areEqual);
	}
	
}	
